//
//ASI_Touch_2.1.mq4
//Dmitry Gritskevich
//           ASI  2
//
//---  
#property indicator_separate_window
#property indicator_buffers 1
//
//--- 
// 
extern int PeriodFastest=36;
extern int PeriodFast=72;
extern int PeriodMedium=144;
extern int PeriodSlow=432;
//    
extern bool UseFastest=true;
extern bool UseFast=true;
extern bool UseMedium=true;
extern bool UseSlow=true;
//     
extern int Space=0;
/*    /   .
       /*/
extern int WindowBeforeTouch=6;
/* 
  /     ( )*/
extern int Precision=10;
//
//---  
double Touch[];
//
//---  
int i;				// 
double MAFastest, MAFast, MAMedium, MASlow;		// 
int Parade=0;			//   ; (1) -  ; (-1) -  
bool WatchFastest=true, WatchFast=true, WatchMedium=true, WatchSlow=true;	//    
//
int init()
{
SetIndexBuffer(0,Touch);        			//  
SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2,DimGray);	// 
IndicatorShortName("ASI_Touch v2.1, Space="+Space+", WindowBeforeTouch="+WindowBeforeTouch+", Precision="+Precision+" |"); 
SetIndexLabel(0,"Touch"); 				//     " "
SetLevelValue(0,0);
SetLevelStyle(STYLE_DOT,1,Black);
IndicatorDigits(0);
return; 
}
//
int start()
{
int Counted_bars=IndicatorCounted();		//   
i=Bars-Counted_bars-1;					//   
//---       	
for(;i>=0;i--)
{
	//---  
	WatchParade();
	//---    
	//     /  -   ,        
	if(Parade==0)
		continue;
	else
		WatchEMA(Parade);
	//---  
	WatchTouch(Parade);
}
return;
}
//
//---   
void WatchParade()
{
MAFastest=NormalizeDouble(iMA(NULL,0,PeriodFastest,0,MODE_EMA,PRICE_CLOSE,i),Digits);
MAFast=NormalizeDouble(iMA(NULL,0,PeriodFast,0,MODE_EMA,PRICE_CLOSE,i),Digits); 
MAMedium=NormalizeDouble(iMA(NULL,0,PeriodMedium,0,MODE_EMA,PRICE_CLOSE,i),Digits);
MASlow=NormalizeDouble(iMA(NULL,0,PeriodSlow,0,MODE_EMA,PRICE_CLOSE,i),Digits);
if(MAFast>MAMedium&&MAMedium>MASlow)		// 
{
	Parade=1;
	return;
}
else
{
	if(MAFast<MAMedium&&MAMedium<MASlow)	// 
	{
		Parade=-1;
		return;
	}
	else								//  ,
	{
		Parade=0;
		WatchFastest=true;		//  ,             
		WatchFast=true;
		WatchMedium=true;
		WatchSlow=true;
	}
}
return;
}
//
//---     
void WatchEMA(int Direction)
{
if(UseFastest&&WatchFastest)			//    
{
	double MAFastest1=NormalizeDouble(iMA(NULL,0,PeriodFastest,0,MODE_EMA,PRICE_CLOSE,i+1),Digits);	//   
	if((Direction==1&&MAFastest<MAFastest1-Precision*Point)||(Direction==-1&&MAFastest>MAFastest1+Precision*Point)) //    (),
		WatchFastest=false;			//   ,         
}
if(UseFast&&WatchFast)
{
	double MAFast1=NormalizeDouble(iMA(NULL,0,PeriodFast,0,MODE_EMA,PRICE_CLOSE,i+1),Digits);
	if((Direction==1&&MAFast<MAFast1-Precision*Point)||(Direction==-1&&MAFast>MAFast1+Precision*Point))
		WatchFast=false;
}
if(UseMedium&&WatchMedium)
{
	double MAMedium1=NormalizeDouble(iMA(NULL,0,PeriodMedium,0,MODE_EMA,PRICE_CLOSE,i+1),Digits);
	if((Direction==1&&MAMedium<MAMedium1-Precision*Point)||(Direction==-1&&MAMedium>MAMedium1+Precision*Point))
		WatchMedium=false;
}
if(UseSlow&&WatchSlow)
{
	double MASlow1=NormalizeDouble(iMA(NULL,0,PeriodSlow,0,MODE_EMA,PRICE_CLOSE,i+1),Digits);
	if((Direction==1&&MASlow<MASlow1-Precision*Point)||(Direction==-1&&MASlow>MASlow1+Precision*Point))
		WatchSlow=false;
}
return;
}
//
//---   
void WatchTouch(int Direction)
{
	if(Direction==1)
	{
		//     , ..        
		if(UseSlow)
		{
			// ,      ,          
			if((Low[i]-MASlow)<=Space*Point&&Function1(Direction,PeriodSlow)&&WatchSlow)
			{
				Touch[i]=PeriodSlow;
				return;
			}
		}
		if(UseMedium)
		{
			if((Low[i]-MAMedium)<=Space*Point&&Function1(Direction,PeriodMedium)&&WatchMedium)
			{
				Touch[i]=PeriodMedium;
				return;
			}
		}
		if(UseFast)
		{
			if((Low[i]-MAFast)<=Space*Point&&Function1(Direction,PeriodFast)&&WatchFast)
			{
				Touch[i]=PeriodFast;
				return;
			}
		}
		if(UseFastest)
		{
			if((Low[i]-MAFastest)<=Space*Point&&Function1(Direction,PeriodFastest)&&WatchFastest)
			{
				Touch[i]=PeriodFastest;
				return;
			}
		}
		Touch[i]=0;
		return;
	}
	if(Direction==-1)
	{
		//     , ..        
		if(UseSlow)
		{
			//   ,      ,          
			if((MASlow-High[i])<=Space*Point&&Function1(Direction,PeriodSlow)&&WatchSlow)
			{
				Touch[i]=PeriodSlow;
				return;
			}
		}
		if(UseMedium)
		{
			//    (     Space )      
			if((MAMedium-High[i])<=Space*Point&&Function1(Direction,PeriodMedium)&&WatchMedium)
			{
				Touch[i]=PeriodMedium;
				return;
			}
		}
		if(UseFast)
		{
			//    (     Space )      
			if((MAFast-High[i])<=Space*Point&&Function1(Direction,PeriodFast)&&WatchFast)
			{
				Touch[i]=PeriodFast;
				return;
			}
		}
		if(UseFastest)
		{
			//    (     Space )      
			if((MAFastest-High[i])<=Space*Point&&Function1(Direction,PeriodFastest)&&WatchFastest)
			{
				Touch[i]=PeriodFastest;
				return;
			}
		}
		Touch[i]=0;
	}
return;
}
//
//---  ,      /
bool Function1(int Trend, int PeriodEMA)
{
int k;
bool Flag=true;
for(k=1;k<=WindowBeforeTouch;k++)
	{	
		if(Trend==1)
		{
			//    -  
			if((Low[i+k]-NormalizeDouble(iMA(NULL,0,PeriodEMA,0,MODE_EMA,PRICE_CLOSE,i+k),Digits))>Space*Point)
				continue;
			//    ,   ,    
			else
			{
				Flag=false;
				break;
			}
		}
		if(Trend==-1)
		{
			//    -  
			if((NormalizeDouble(iMA(NULL,0,PeriodEMA,0,MODE_EMA,PRICE_CLOSE,i+k),Digits)-High[i+k])>Space*Point)
				continue;
			//    ,   ,    
			else
			{
				Flag=false;
				break;
			}
		}
	}
return(Flag);
}
//